// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: breakermodule/breakermodule.proto

package openfmb.breakermodule;

/**
 * <pre>
 * Breaker discrete control class
 * </pre>
 *
 * Protobuf type {@code breakermodule.BreakerDiscreteControl}
 */
public final class BreakerDiscreteControl extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:breakermodule.BreakerDiscreteControl)
    BreakerDiscreteControlOrBuilder {
private static final long serialVersionUID = 0L;
  // Use BreakerDiscreteControl.newBuilder() to construct.
  private BreakerDiscreteControl(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private BreakerDiscreteControl() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new BreakerDiscreteControl();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.breakermodule.Breakermodule.internal_static_breakermodule_BreakerDiscreteControl_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.breakermodule.Breakermodule.internal_static_breakermodule_BreakerDiscreteControl_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.breakermodule.BreakerDiscreteControl.class, openfmb.breakermodule.BreakerDiscreteControl.Builder.class);
  }

  public static final int CONTROLVALUE_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ControlValue controlValue_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the controlValue field is set.
   */
  @java.lang.Override
  public boolean hasControlValue() {
    return controlValue_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
   * @return The controlValue.
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlValue getControlValue() {
    return controlValue_ == null ? openfmb.commonmodule.ControlValue.getDefaultInstance() : controlValue_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlValueOrBuilder getControlValueOrBuilder() {
    return controlValue_ == null ? openfmb.commonmodule.ControlValue.getDefaultInstance() : controlValue_;
  }

  public static final int CHECK_FIELD_NUMBER = 2;
  private openfmb.commonmodule.CheckConditions check_;
  /**
   * <pre>
   * IEC61850 enhanced control parameters.
   * </pre>
   *
   * <code>.commonmodule.CheckConditions check = 2;</code>
   * @return Whether the check field is set.
   */
  @java.lang.Override
  public boolean hasCheck() {
    return check_ != null;
  }
  /**
   * <pre>
   * IEC61850 enhanced control parameters.
   * </pre>
   *
   * <code>.commonmodule.CheckConditions check = 2;</code>
   * @return The check.
   */
  @java.lang.Override
  public openfmb.commonmodule.CheckConditions getCheck() {
    return check_ == null ? openfmb.commonmodule.CheckConditions.getDefaultInstance() : check_;
  }
  /**
   * <pre>
   * IEC61850 enhanced control parameters.
   * </pre>
   *
   * <code>.commonmodule.CheckConditions check = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.CheckConditionsOrBuilder getCheckOrBuilder() {
    return check_ == null ? openfmb.commonmodule.CheckConditions.getDefaultInstance() : check_;
  }

  public static final int BREAKERDISCRETECONTROLXCBR_FIELD_NUMBER = 3;
  private openfmb.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
   * @return Whether the breakerDiscreteControlXCBR field is set.
   */
  @java.lang.Override
  public boolean hasBreakerDiscreteControlXCBR() {
    return breakerDiscreteControlXCBR_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
   * @return The breakerDiscreteControlXCBR.
   */
  @java.lang.Override
  public openfmb.breakermodule.BreakerDiscreteControlXCBR getBreakerDiscreteControlXCBR() {
    return breakerDiscreteControlXCBR_ == null ? openfmb.breakermodule.BreakerDiscreteControlXCBR.getDefaultInstance() : breakerDiscreteControlXCBR_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
   */
  @java.lang.Override
  public openfmb.breakermodule.BreakerDiscreteControlXCBROrBuilder getBreakerDiscreteControlXCBROrBuilder() {
    return breakerDiscreteControlXCBR_ == null ? openfmb.breakermodule.BreakerDiscreteControlXCBR.getDefaultInstance() : breakerDiscreteControlXCBR_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (controlValue_ != null) {
      output.writeMessage(1, getControlValue());
    }
    if (check_ != null) {
      output.writeMessage(2, getCheck());
    }
    if (breakerDiscreteControlXCBR_ != null) {
      output.writeMessage(3, getBreakerDiscreteControlXCBR());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (controlValue_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getControlValue());
    }
    if (check_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getCheck());
    }
    if (breakerDiscreteControlXCBR_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getBreakerDiscreteControlXCBR());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.breakermodule.BreakerDiscreteControl)) {
      return super.equals(obj);
    }
    openfmb.breakermodule.BreakerDiscreteControl other = (openfmb.breakermodule.BreakerDiscreteControl) obj;

    if (hasControlValue() != other.hasControlValue()) return false;
    if (hasControlValue()) {
      if (!getControlValue()
          .equals(other.getControlValue())) return false;
    }
    if (hasCheck() != other.hasCheck()) return false;
    if (hasCheck()) {
      if (!getCheck()
          .equals(other.getCheck())) return false;
    }
    if (hasBreakerDiscreteControlXCBR() != other.hasBreakerDiscreteControlXCBR()) return false;
    if (hasBreakerDiscreteControlXCBR()) {
      if (!getBreakerDiscreteControlXCBR()
          .equals(other.getBreakerDiscreteControlXCBR())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasControlValue()) {
      hash = (37 * hash) + CONTROLVALUE_FIELD_NUMBER;
      hash = (53 * hash) + getControlValue().hashCode();
    }
    if (hasCheck()) {
      hash = (37 * hash) + CHECK_FIELD_NUMBER;
      hash = (53 * hash) + getCheck().hashCode();
    }
    if (hasBreakerDiscreteControlXCBR()) {
      hash = (37 * hash) + BREAKERDISCRETECONTROLXCBR_FIELD_NUMBER;
      hash = (53 * hash) + getBreakerDiscreteControlXCBR().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.breakermodule.BreakerDiscreteControl parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.breakermodule.BreakerDiscreteControl parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.breakermodule.BreakerDiscreteControl parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.breakermodule.BreakerDiscreteControl parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.breakermodule.BreakerDiscreteControl parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.breakermodule.BreakerDiscreteControl parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.breakermodule.BreakerDiscreteControl parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.breakermodule.BreakerDiscreteControl parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.breakermodule.BreakerDiscreteControl parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.breakermodule.BreakerDiscreteControl parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.breakermodule.BreakerDiscreteControl parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.breakermodule.BreakerDiscreteControl parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.breakermodule.BreakerDiscreteControl prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Breaker discrete control class
   * </pre>
   *
   * Protobuf type {@code breakermodule.BreakerDiscreteControl}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:breakermodule.BreakerDiscreteControl)
      openfmb.breakermodule.BreakerDiscreteControlOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.breakermodule.Breakermodule.internal_static_breakermodule_BreakerDiscreteControl_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.breakermodule.Breakermodule.internal_static_breakermodule_BreakerDiscreteControl_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.breakermodule.BreakerDiscreteControl.class, openfmb.breakermodule.BreakerDiscreteControl.Builder.class);
    }

    // Construct using openfmb.breakermodule.BreakerDiscreteControl.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      controlValue_ = null;
      if (controlValueBuilder_ != null) {
        controlValueBuilder_.dispose();
        controlValueBuilder_ = null;
      }
      check_ = null;
      if (checkBuilder_ != null) {
        checkBuilder_.dispose();
        checkBuilder_ = null;
      }
      breakerDiscreteControlXCBR_ = null;
      if (breakerDiscreteControlXCBRBuilder_ != null) {
        breakerDiscreteControlXCBRBuilder_.dispose();
        breakerDiscreteControlXCBRBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.breakermodule.Breakermodule.internal_static_breakermodule_BreakerDiscreteControl_descriptor;
    }

    @java.lang.Override
    public openfmb.breakermodule.BreakerDiscreteControl getDefaultInstanceForType() {
      return openfmb.breakermodule.BreakerDiscreteControl.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.breakermodule.BreakerDiscreteControl build() {
      openfmb.breakermodule.BreakerDiscreteControl result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.breakermodule.BreakerDiscreteControl buildPartial() {
      openfmb.breakermodule.BreakerDiscreteControl result = new openfmb.breakermodule.BreakerDiscreteControl(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.breakermodule.BreakerDiscreteControl result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.controlValue_ = controlValueBuilder_ == null
            ? controlValue_
            : controlValueBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.check_ = checkBuilder_ == null
            ? check_
            : checkBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.breakerDiscreteControlXCBR_ = breakerDiscreteControlXCBRBuilder_ == null
            ? breakerDiscreteControlXCBR_
            : breakerDiscreteControlXCBRBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.breakermodule.BreakerDiscreteControl) {
        return mergeFrom((openfmb.breakermodule.BreakerDiscreteControl)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.breakermodule.BreakerDiscreteControl other) {
      if (other == openfmb.breakermodule.BreakerDiscreteControl.getDefaultInstance()) return this;
      if (other.hasControlValue()) {
        mergeControlValue(other.getControlValue());
      }
      if (other.hasCheck()) {
        mergeCheck(other.getCheck());
      }
      if (other.hasBreakerDiscreteControlXCBR()) {
        mergeBreakerDiscreteControlXCBR(other.getBreakerDiscreteControlXCBR());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getControlValueFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getCheckFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getBreakerDiscreteControlXCBRFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ControlValue controlValue_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlValue, openfmb.commonmodule.ControlValue.Builder, openfmb.commonmodule.ControlValueOrBuilder> controlValueBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the controlValue field is set.
     */
    public boolean hasControlValue() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
     * @return The controlValue.
     */
    public openfmb.commonmodule.ControlValue getControlValue() {
      if (controlValueBuilder_ == null) {
        return controlValue_ == null ? openfmb.commonmodule.ControlValue.getDefaultInstance() : controlValue_;
      } else {
        return controlValueBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlValue(openfmb.commonmodule.ControlValue value) {
      if (controlValueBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        controlValue_ = value;
      } else {
        controlValueBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlValue(
        openfmb.commonmodule.ControlValue.Builder builderForValue) {
      if (controlValueBuilder_ == null) {
        controlValue_ = builderForValue.build();
      } else {
        controlValueBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeControlValue(openfmb.commonmodule.ControlValue value) {
      if (controlValueBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          controlValue_ != null &&
          controlValue_ != openfmb.commonmodule.ControlValue.getDefaultInstance()) {
          getControlValueBuilder().mergeFrom(value);
        } else {
          controlValue_ = value;
        }
      } else {
        controlValueBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearControlValue() {
      bitField0_ = (bitField0_ & ~0x00000001);
      controlValue_ = null;
      if (controlValueBuilder_ != null) {
        controlValueBuilder_.dispose();
        controlValueBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlValue.Builder getControlValueBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getControlValueFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlValueOrBuilder getControlValueOrBuilder() {
      if (controlValueBuilder_ != null) {
        return controlValueBuilder_.getMessageOrBuilder();
      } else {
        return controlValue_ == null ?
            openfmb.commonmodule.ControlValue.getDefaultInstance() : controlValue_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlValue controlValue = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlValue, openfmb.commonmodule.ControlValue.Builder, openfmb.commonmodule.ControlValueOrBuilder> 
        getControlValueFieldBuilder() {
      if (controlValueBuilder_ == null) {
        controlValueBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ControlValue, openfmb.commonmodule.ControlValue.Builder, openfmb.commonmodule.ControlValueOrBuilder>(
                getControlValue(),
                getParentForChildren(),
                isClean());
        controlValue_ = null;
      }
      return controlValueBuilder_;
    }

    private openfmb.commonmodule.CheckConditions check_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.CheckConditions, openfmb.commonmodule.CheckConditions.Builder, openfmb.commonmodule.CheckConditionsOrBuilder> checkBuilder_;
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     * @return Whether the check field is set.
     */
    public boolean hasCheck() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     * @return The check.
     */
    public openfmb.commonmodule.CheckConditions getCheck() {
      if (checkBuilder_ == null) {
        return check_ == null ? openfmb.commonmodule.CheckConditions.getDefaultInstance() : check_;
      } else {
        return checkBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public Builder setCheck(openfmb.commonmodule.CheckConditions value) {
      if (checkBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        check_ = value;
      } else {
        checkBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public Builder setCheck(
        openfmb.commonmodule.CheckConditions.Builder builderForValue) {
      if (checkBuilder_ == null) {
        check_ = builderForValue.build();
      } else {
        checkBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public Builder mergeCheck(openfmb.commonmodule.CheckConditions value) {
      if (checkBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          check_ != null &&
          check_ != openfmb.commonmodule.CheckConditions.getDefaultInstance()) {
          getCheckBuilder().mergeFrom(value);
        } else {
          check_ = value;
        }
      } else {
        checkBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public Builder clearCheck() {
      bitField0_ = (bitField0_ & ~0x00000002);
      check_ = null;
      if (checkBuilder_ != null) {
        checkBuilder_.dispose();
        checkBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public openfmb.commonmodule.CheckConditions.Builder getCheckBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getCheckFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public openfmb.commonmodule.CheckConditionsOrBuilder getCheckOrBuilder() {
      if (checkBuilder_ != null) {
        return checkBuilder_.getMessageOrBuilder();
      } else {
        return check_ == null ?
            openfmb.commonmodule.CheckConditions.getDefaultInstance() : check_;
      }
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.CheckConditions, openfmb.commonmodule.CheckConditions.Builder, openfmb.commonmodule.CheckConditionsOrBuilder> 
        getCheckFieldBuilder() {
      if (checkBuilder_ == null) {
        checkBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.CheckConditions, openfmb.commonmodule.CheckConditions.Builder, openfmb.commonmodule.CheckConditionsOrBuilder>(
                getCheck(),
                getParentForChildren(),
                isClean());
        check_ = null;
      }
      return checkBuilder_;
    }

    private openfmb.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.breakermodule.BreakerDiscreteControlXCBR, openfmb.breakermodule.BreakerDiscreteControlXCBR.Builder, openfmb.breakermodule.BreakerDiscreteControlXCBROrBuilder> breakerDiscreteControlXCBRBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
     * @return Whether the breakerDiscreteControlXCBR field is set.
     */
    public boolean hasBreakerDiscreteControlXCBR() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
     * @return The breakerDiscreteControlXCBR.
     */
    public openfmb.breakermodule.BreakerDiscreteControlXCBR getBreakerDiscreteControlXCBR() {
      if (breakerDiscreteControlXCBRBuilder_ == null) {
        return breakerDiscreteControlXCBR_ == null ? openfmb.breakermodule.BreakerDiscreteControlXCBR.getDefaultInstance() : breakerDiscreteControlXCBR_;
      } else {
        return breakerDiscreteControlXCBRBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
     */
    public Builder setBreakerDiscreteControlXCBR(openfmb.breakermodule.BreakerDiscreteControlXCBR value) {
      if (breakerDiscreteControlXCBRBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        breakerDiscreteControlXCBR_ = value;
      } else {
        breakerDiscreteControlXCBRBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
     */
    public Builder setBreakerDiscreteControlXCBR(
        openfmb.breakermodule.BreakerDiscreteControlXCBR.Builder builderForValue) {
      if (breakerDiscreteControlXCBRBuilder_ == null) {
        breakerDiscreteControlXCBR_ = builderForValue.build();
      } else {
        breakerDiscreteControlXCBRBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
     */
    public Builder mergeBreakerDiscreteControlXCBR(openfmb.breakermodule.BreakerDiscreteControlXCBR value) {
      if (breakerDiscreteControlXCBRBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          breakerDiscreteControlXCBR_ != null &&
          breakerDiscreteControlXCBR_ != openfmb.breakermodule.BreakerDiscreteControlXCBR.getDefaultInstance()) {
          getBreakerDiscreteControlXCBRBuilder().mergeFrom(value);
        } else {
          breakerDiscreteControlXCBR_ = value;
        }
      } else {
        breakerDiscreteControlXCBRBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
     */
    public Builder clearBreakerDiscreteControlXCBR() {
      bitField0_ = (bitField0_ & ~0x00000004);
      breakerDiscreteControlXCBR_ = null;
      if (breakerDiscreteControlXCBRBuilder_ != null) {
        breakerDiscreteControlXCBRBuilder_.dispose();
        breakerDiscreteControlXCBRBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
     */
    public openfmb.breakermodule.BreakerDiscreteControlXCBR.Builder getBreakerDiscreteControlXCBRBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getBreakerDiscreteControlXCBRFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
     */
    public openfmb.breakermodule.BreakerDiscreteControlXCBROrBuilder getBreakerDiscreteControlXCBROrBuilder() {
      if (breakerDiscreteControlXCBRBuilder_ != null) {
        return breakerDiscreteControlXCBRBuilder_.getMessageOrBuilder();
      } else {
        return breakerDiscreteControlXCBR_ == null ?
            openfmb.breakermodule.BreakerDiscreteControlXCBR.getDefaultInstance() : breakerDiscreteControlXCBR_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.breakermodule.BreakerDiscreteControlXCBR breakerDiscreteControlXCBR = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.breakermodule.BreakerDiscreteControlXCBR, openfmb.breakermodule.BreakerDiscreteControlXCBR.Builder, openfmb.breakermodule.BreakerDiscreteControlXCBROrBuilder> 
        getBreakerDiscreteControlXCBRFieldBuilder() {
      if (breakerDiscreteControlXCBRBuilder_ == null) {
        breakerDiscreteControlXCBRBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.breakermodule.BreakerDiscreteControlXCBR, openfmb.breakermodule.BreakerDiscreteControlXCBR.Builder, openfmb.breakermodule.BreakerDiscreteControlXCBROrBuilder>(
                getBreakerDiscreteControlXCBR(),
                getParentForChildren(),
                isClean());
        breakerDiscreteControlXCBR_ = null;
      }
      return breakerDiscreteControlXCBRBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:breakermodule.BreakerDiscreteControl)
  }

  // @@protoc_insertion_point(class_scope:breakermodule.BreakerDiscreteControl)
  private static final openfmb.breakermodule.BreakerDiscreteControl DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.breakermodule.BreakerDiscreteControl();
  }

  public static openfmb.breakermodule.BreakerDiscreteControl getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<BreakerDiscreteControl>
      PARSER = new com.google.protobuf.AbstractParser<BreakerDiscreteControl>() {
    @java.lang.Override
    public BreakerDiscreteControl parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<BreakerDiscreteControl> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<BreakerDiscreteControl> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.breakermodule.BreakerDiscreteControl getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

